# Supported GraphQL Query Rules

## ExecutableDefinitions (5.1.1)

> Specification section: **[Executable Definitions](https://graphql.github.io/graphql-spec/June2018/#sec-Executable-Definitions)**

## UniqueOperationNames (5.2.1.1)

> Specification section: **[Operation Name Uniqueness](https://graphql.github.io/graphql-spec/June2018/#sec-Operation-Name-Uniqueness)**

## LoneAnonymousOperation (5.2.2.1)

> Specification section: **[Lone Anonymous Operation](https://graphql.github.io/graphql-spec/June2018/#sec-Lone-Anonymous-Operation)**

## SingleFieldSubscriptions (5.2.3.1)

> Specification section: **[Subscriptions with Single Root Field](https://graphql.github.io/graphql-spec/June2018/#sec-Single-root-field)**

## FieldsOnCorrectType (5.3.1)

> Specification section: **[Field Selections on Objects, Interfaces, and Unions Types](https://graphql.github.io/graphql-spec/June2018/#sec-Field-Selections-on-Objects-Interfaces-and-Unions-Types)**

## ScalarLeafs (5.3.3)

> Specification section: **[Leaf Field Selections](https://graphql.github.io/graphql-spec/June2018/#sec-Leaf-Field-Selections)**

## KnownArgumentNames (5.4.1)

> Specification section: **[Argument Names](https://graphql.github.io/graphql-spec/June2018/#sec-Argument-Names)**

## UniqueArgumentNames (5.4.2)

> Specification section: **[Argument Uniqueness](https://graphql.github.io/graphql-spec/June2018/#sec-Argument-Uniqueness)**

## ProvidedRequiredArguments (5.4.2.1)

> Specification section: **[Argument Optionality](https://graphql.github.io/graphql-spec/June2018/#sec-Required-Arguments)**

## UniqueFragmentNames (5.5.1.1)

> Specification section: **[Fragment Name Uniqueness](https://graphql.github.io/graphql-spec/June2018/#sec-Fragment-Name-Uniqueness)**

## KnownTypeNames (5.5.1.2)

> Specification section: **[Fragment Spread Type Existence](https://graphql.github.io/graphql-spec/June2018/#sec-Fragment-Spread-Type-Existence)**

## FragmentsOnCompositeTypes (5.5.1.3)

> Specification section: **[Fragments on Composite Types](https://graphql.github.io/graphql-spec/June2018/#sec-Fragments-On-Composite-Types)**

## NoUnusedFragments (5.5.1.4)

> Specification section: **[Fragments must be used](https://graphql.github.io/graphql-spec/June2018/#sec-Fragments-Must-Be-Used)**

## KnownFragmentNames (5.5.2.1)

> Specification section: **[Fragment spread target defined](https://graphql.github.io/graphql-spec/June2018/#sec-Fragment-spread-target-defined)**

## NoFragmentCycles (5.5.2.2)

> Specification section: **[Fragments must not form cycles](https://graphql.github.io/graphql-spec/June2018/#sec-Fragment-spreads-must-not-form-cycles)**

## PossibleFragmentSpreads (5.5.2.3)

> Specification section: **[Fragment spread is possible](https://graphql.github.io/graphql-spec/June2018/#sec-Fragment-spread-is-possible)**

## ValuesOfCorrectType (5.6.1)

> Specification section: **[Value Type Correctness](https://graphql.github.io/graphql-spec/June2018/#sec-Values-of-Correct-Type)**

## UniqueInputFieldNames (5.6.3)

> Specification section: **[Input Object Field Uniqueness](https://graphql.github.io/graphql-spec/June2018/#sec-Input-Object-Field-Uniqueness)**

## KnownDirectives (5.7.1)

> Specification section: **[Directives Are Defined](https://graphql.github.io/graphql-spec/June2018/#sec-Directives-Are-Defined)**

## DirectivesInValidLocations (5.7.2)

> Specification section: **[Directives In Valid Locations](https://graphql.github.io/graphql-spec/June2018/#sec-Directives-Are-In-Valid-Locations)**

## UniqueDirectivesPerLocation (5.7.3)

> Specification section: **[Directives Are Unique Per Location](https://graphql.github.io/graphql-spec/June2018/#sec-Directives-Are-Unique-Per-Location)**

## UniqueVariableNames (5.8.1)

> Specification section: **[Variable Uniqueness](https://graphql.github.io/graphql-spec/June2018/#sec-Variable-Uniqueness)**

## VariablesAreInputTypes (5.8.2)

> Specification section: **[Variables are Input Types](https://graphql.github.io/graphql-spec/June2018/#sec-Variables-Are-Input-Types)**

## NoUndefinedVariables (5.8.3)

> Specification section: **[All Variable Used Defined](https://graphql.github.io/graphql-spec/June2018/#sec-All-Variable-Uses-Defined)**

## NoUnusedVariables (5.8.4)

> Specification section: **[All Variables Used](https://graphql.github.io/graphql-spec/June2018/#sec-All-Variables-Used)**

## VariablesInAllowedPosition (5.8.5)

> Specification section: **[All Variable Usages Are Allowed](https://graphql.github.io/graphql-spec/June2018/#sec-All-Variable-Usages-are-Allowed)**
